package com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.mapper;

import com.jeeplus.core.persistence.BaseMapper;
import com.jeeplus.core.persistence.annotation.MyBatisMapper;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.ReservePreconstruction;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.History;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 储备项目预土建制化信息 mapper
 * @author: 王强
 * @create: 2022-07-26 09:42
 **/
@MyBatisMapper
public interface ReservePreconstructMapper extends BaseMapper<ReservePreconstruction> {

    /**
     * 修改设计预制化信息
     */
    void updateMetion(@Param("designCivilFoundation") String designCivilFoundation,
                      @Param("castInPlaceList") String castInPlaceList,
                      @Param("designList") String designList);

    /**
     * 获取所有的  项目储备编号
     * @return
     */
    List<String> getAllProId();

    /**
     * 从基本数据表中获取所有的  项目储备编号
     * @return
     */
    List<String> getAllProId2();

    /**
     * 根据项目储备id查询项目信息
     * @param reserveManagement
     * @return
     */
    ReservePreconstruction queryByProjectReserveId(ReservePreconstruction reserveManagement);

    /**
     * 批量添加项目储备信息
     * @param list
     * @return
     */
    void insertList(@Param("list") List<ReservePreconstruction> list);

    /**
     * 导出数据查询
     * @param reserveManagement
     * @return
     */
    List<ReservePreconstruction> exportFindList(ReservePreconstruction reserveManagement);

    /**
     * 根据projectReserveId查出proc_ins_id
     * @param projectReserveId
     * @return
     */
    String getByProjectReserveId(String projectReserveId);

    /**
     * 根据executeId查出历史节点信息
     * @param executeId
     * @return
     */
    List<History> getHistoryByExecuteId(String executeId);

    /**
     * 根据executeId查出当前节点的名称
     * @param executeId
     * @return
     */
    String getByExecuteId(String executeId);
}
