package com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.utils;

import redis.clients.jedis.Jedis;

import java.util.List;

/**
 * @author: 王强
 * @create: 2022-08-26 10:49
 **/
public class DataList {

    /*存储list集合*/
    public static void setList(String key, List<?> value){
        Jedis jedis = ReserveRedisUtils.getJedis();
        try {
            if (value == null || value.size() == 0){
                jedis.set(key.getBytes(),"".getBytes());
            }
            jedis.set(key.getBytes(),SerializableUtilsList.serializeList(value));
            /*存储过期时间*/
            jedis.expire(key,60*30);
        }catch (Exception e){
            e.printStackTrace();
        }finally {
            jedis.close();
        }
    }

    /*取出list集合*/
    public static List<?> getList(String key){
        Jedis jedis = ReserveRedisUtils.getJedis();
        if (jedis == null || !jedis.exists(key)){
            return null;
        }
        byte[] data = jedis.get(key.getBytes());
        jedis.close();
        return SerializableUtilsList.usSerializeList(data);
    }
}
