package com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.utils;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.List;


import static com.alibaba.fastjson.util.IOUtils.close;
/**
 * list序=序列化工具类
 * @author: 王强
 * @create: 2022-08-26 10:22
 **/
public class SerializableUtilsList {

    /*序列化list集合*/
    public static byte[] serializeList(List<?> list){
        if (list == null || list.size() == 0){
            return null;
        }
        ObjectOutputStream oos = null;
        ByteArrayOutputStream baos = null;
        byte[] bytes = null;
        try {
            baos = new ByteArrayOutputStream();
            oos = new ObjectOutputStream(baos);
            for (Object o : list) {
                oos.writeObject(o);
            }
            bytes = baos.toByteArray();
        }catch (Exception e){
            e.printStackTrace();
        }finally {
            close(oos);
            close(baos);
        }
        return bytes;
    }

    /*反序列化list集合*/
    public static List<?> usSerializeList(byte[] bytes){
        if (bytes == null) {
            return null;
        }
        List<Object> list = new ArrayList<>();
        ByteArrayInputStream bais = null;
        ObjectInputStream ois = null;
        try {
            bais = new ByteArrayInputStream(bytes);
            ois = new ObjectInputStream(bais);
            /*剩余可读字节数*/
            while (bais.available() >0){
                Object object = ois.readObject();
                if (object == null) {
                    break;
                }
                list.add(object);
            }
        }catch (Exception e){
            e.printStackTrace();
        }finally {
            close(bais);
            close(ois);
        }
        return list;
    }
}
