package com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.web;

import com.jeeplus.common.json.AjaxJson;
import com.jeeplus.common.utils.StringUtils;
import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.web.BaseController;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.ActRunTaskTest;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.CompanyReview;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.entity.ReserveSummary;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.service.CompanyReviewService;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.service.ReserveProcessProjectService;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.service.ReserveSummaryProcessService;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.service.SummaryStatisticService;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.utils.ReserveProcessProjectExportUtil;
import com.jeeplus.modules.cg.reservemanagementcenter.reserveManage.utils.ReserveProcessProjectProUtil;
import com.jeeplus.modules.sg.managementcenter.materialproject.util.ImportUtil;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.apache.shiro.authz.annotation.Logical;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Map;

/**
 * 省公司评审
 * @author: 王强
 * @create: 2022-10-24 16:02
 **/
@Controller
@RequestMapping(value = "${adminPath}/cg/reservemanagementcenter/companyReview")
public class CompanyReviewController extends BaseController {

    @Autowired
    private CompanyReviewService service;

    @Autowired
    private SummaryStatisticService statisticService;

    @Autowired
    private ReserveProcessProjectService projectService;

    @Autowired
    private ReserveSummaryProcessService summaryProcessService;

    @ModelAttribute
    public CompanyReview get(@RequestParam(required = false) String id) {
        CompanyReview entity = null;
        if (StringUtils.isNotBlank(id)) {
            entity = service.get(id);
        }
        if (entity == null) {
            entity = new CompanyReview();
        }
        return entity;
    }

    /**
     * 省公司评审信息列表页面
     * @param review
     * @param model
     * @return
     */
    @RequiresPermissions("cg:reservemanagementcenter:companyReview:list")
    @RequestMapping(value = "skipList")
    public String skipList(CompanyReview review, Model model) {
        model.addAttribute("review", review);
        return "modules/cg/reservemanagementcenter/reserveManage/companyReview/companyReviewInfo";
    }

    /**
     * 导入Excel数据
     */
    @ResponseBody
    @RequiresPermissions("cg:reservemanagementcenter:companyReview:import")
    @RequestMapping(value = "import")
    public AjaxJson importBasic(@RequestParam("file") MultipartFile file, HttpServletResponse response, HttpServletRequest request) {
        AjaxJson j = new AjaxJson();
        try {
            ImportUtil importUtil = new ImportUtil(file, 0, 0);
            //获取数据库中已有的编码数据
            List<String> proIdList = service.getAllProId();
            //去汇总表中查出所有的 项目编码
            List<String> proIdList2 = service.getAllProId2();

            //获取汇总表中的数据  物料编码 和 是否纳入储备字段
            List<ReserveSummary> allCode = statisticService.getAllCode();

            //获取导入表格所有数据
            List<CompanyReview> companyReviewList = ReserveProcessProjectProUtil.getCompanyUtil(importUtil,proIdList,proIdList2);
            //对 是否通过省公司评审字段进行判断
            //两种情况  1、在流程中  2、流程未开始
            companyReviewList.forEach(c->{
                allCode.forEach(a->{
                    //通过省公司评审的状态
                    if (c.getPassProvincialCompanyReview().equals("通过") & a.getProjectReserveId().equals(c.getProjectReserveId())){

                    }else if (c.getPassProvincialCompanyReview().equals("取消") & a.getProjectReserveId().equals(c.getProjectReserveId())){
                        //取消的状态
                        //流程开始的状态
                        if (a.getIncludeReserve().equals("是")){
                            //修改基础表的流程字段为取消，修改汇总表的是否纳入储备为取消，将取消原因放入到汇总表的取消原因说明字段 结束流程
                            projectService.updateProcessStatus(a.getProjectReserveId(),3);

                            ReserveSummary summary = new ReserveSummary();
                            summary.setProjectReserveId(a.getProjectReserveId());
                            ReserveSummary summary1 = statisticService.queryByProjectReserveId(summary);
                            summary1.setIncludeReserve("取消");
                            summary1.setReasonForCancel(c.getReviewComments());
                            statisticService.update(summary1);

//                            statisticService.updateReserveSummary(a.getProjectReserveId(),"取消",c.getReviewComments());
                            //取消流程   将流程表中的流程信息删除
                            service.deleteActivityByProId(a.getProjectReserveId());

                            //将act_ru_task表中的任务删除
                            ActRunTaskTest taskTest = summaryProcessService.getByProId(c.getProjectReserveId());
                            summaryProcessService.deleteByProcId(taskTest.getProcDefId(),"");
                            //删除联合审图的并行任务
                            summaryProcessService.deleteExecution(taskTest.getProcDefId(),"sid-A0FF4858-9940-4B37-B14E-2DEA24AB37E5");
                            summaryProcessService.deleteExecution(taskTest.getProcDefId(),"sid-C92A1CEE-3775-4A11-AAD0-64FA836AC97C");

                        }
                    }
                });
            });

            //查询已有的参数数据 并分类返回已存在数据和未存在数据
            Map map = service.getExistProjectList(companyReviewList);
            //未存在数据
            List<CompanyReview> withoutList = (List<CompanyReview>) map.get("without");
            //已存在数据
            List<CompanyReview> existList = (List<CompanyReview>) map.get("exist");

            //对未存在的数据进行批量导入
            if(withoutList.size()>0){
                service.insertList(withoutList);
            }

            //对已存在的数据进行修改
            if(existList.size()>0){
                for (CompanyReview companyReview : existList) {
                    service.update(companyReview);
                }
            }
            int i = withoutList.size() + existList.size();
            j.setMsg("已成功导入" + i + "条省公司评审信息记录");

        } catch (Exception e) {
            j.setSuccess(false);
            j.setMsg("导入省公司评审信息失败！失败信息：" + e.getMessage());
        }
        return j;
    }

    /**
     * 编辑表单页面
     * @param companyReview
     * @param model
     * @return
     */
    @RequiresPermissions(value={"cg:reservemanagementcenter:companyReview:add","cg:reservemanagementcenter:companyReview:edit"},logical= Logical.OR)
    @RequestMapping(value = "form")
    public String form(CompanyReview companyReview, Model model) {

        model.addAttribute("companyReview", companyReview);
        //判断id是否为空 如果未空则为新增 否则为修改
        if(StringUtils.isBlank(companyReview.getId())){
            return "modules/cg/reservemanagementcenter/reserveManage/companyReview/companyReviewForm";
        }
        return "modules/cg/reservemanagementcenter/reserveManage/companyReview/companyReviewModifyByzz";
    }

    /**
     * 项目储备信息数据列表
     * @param companyReview
     * @param request
     * @param response
     * @param model
     * @return
     */
    @ResponseBody
    @RequiresPermissions("cg:reservemanagementcenter:companyReview:list")
    @RequestMapping(value = "list")
    public Map<String, Object> basicData(CompanyReview companyReview, HttpServletRequest request, HttpServletResponse response, Model model) {

        Page<CompanyReview> page = service.findPage(new Page<CompanyReview>(request, response), companyReview);
        return getBootstrapData(page);
    }

    //导出excel
    @ResponseBody
    @RequiresPermissions("cg:reservemanagementcenter:companyReview:export")
    @RequestMapping(value = "export")
    public void exportExcel(CompanyReview companyReview, HttpServletRequest request, HttpServletResponse response) {
        List<CompanyReview> list = service.exportFindList(companyReview);

        //生成序列号
        int i = 1;
        for (CompanyReview s : list) {
            s.setId(String.valueOf(i));
            i++;
        }

        ReserveProcessProjectExportUtil util = ReserveProcessProjectExportUtil.getOne();
        XSSFWorkbook workbook = util.getWorkbook("companyReview");
        util.exportCompany(response,workbook,list);
    }

    /**
     * 修改表单
     * @param companyReview
     * @return
     */
    @ResponseBody
    @RequiresPermissions(value={"cg:reservemanagementcenter:companyReview:edit"},logical=Logical.OR)
    @RequestMapping(value = "update")
    public AjaxJson update(CompanyReview companyReview){
        AjaxJson j = new AjaxJson();
        /**
         * 后台hibernate-validation插件校验
         */
        String errMsg = beanValidator(companyReview);
        if (StringUtils.isNotBlank(errMsg)){
            j.setSuccess(false);
            j.setMsg(errMsg);
            return j;
        }
        //修改时的两种情况
        //1、在流程进行中修改(修改基础表的流程字段为取消，修改汇总表的是否纳入储备为取消，将取消原因放入到汇总表的取消原因说明字段 结束流程)
        //2、流程未开始修改（正常操作不进行其他处理）
        if (companyReview.getPassProvincialCompanyReview().equals("取消")){
            projectService.updateProcessStatus(companyReview.getProjectReserveId(),3);

            ReserveSummary summary = new ReserveSummary();
            summary.setProjectReserveId(companyReview.getProjectReserveId());
            ReserveSummary summary1 = statisticService.queryByProjectReserveId(summary);
            summary1.setIncludeReserve("取消");
            summary1.setReasonForCancel(companyReview.getReviewComments());
            statisticService.update(summary1);

            //取消流程   将流程表中的流程信息删除
            service.deleteActivityByProId(companyReview.getProjectReserveId());
            //将act_ru_task表中的任务删除
            ActRunTaskTest taskTest = summaryProcessService.getByProId(companyReview.getProjectReserveId());
            summaryProcessService.deleteByProcId(taskTest.getProcDefId(),"");
            //删除联合审图的并行任务
            summaryProcessService.deleteExecution(taskTest.getProcDefId(),"sid-A0FF4858-9940-4B37-B14E-2DEA24AB37E5");
            summaryProcessService.deleteExecution(taskTest.getProcDefId(),"sid-C92A1CEE-3775-4A11-AAD0-64FA836AC97C");

        }
        //新增或编辑表单保存
        service.update(companyReview);

        j.setSuccess(true);
        j.setMsg("修改储备项目基本信息成功");
        return j;
    }

    /**
     * 查看表单页面
     */
    @RequiresPermissions(value={"cg:reservemanagementcenter:companyReview:view"},logical= Logical.OR)
    @RequestMapping(value = "view")
    public String view(CompanyReview companyReview, Model model) {
        model.addAttribute("companyReview", companyReview);
        return "modules/cg/reservemanagementcenter/reserveManage/companyReview/companyReviewView";
    }
}
