package com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.mapper;

import com.jeeplus.core.persistence.BaseMapper;
import com.jeeplus.core.persistence.annotation.MyBatisMapper;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.History;
import com.jeeplus.modules.cg.reservemanagementcenter.statisticalTable.entity.NormativeAudit;

import java.util.List;

/**
 * 储备项目规范性审核记录表
 * @author: 王强
 * @create: 2022-08-23 10:07
 **/
@MyBatisMapper
public interface NormativeAuditMapper extends BaseMapper<NormativeAudit> {

    /**
     * 导出数据查询
     * @param audit
     * @return
     */
    List<NormativeAudit> exportFindList(NormativeAudit audit);

    /**
     * 根据projectReserveId来判断是否有拆旧清册数据
     * @param projectReserveId
     * @return
     */
    int getCountByProjectReserveId(String projectReserveId);

    /**
     * 根据projectReserveId查出proc_ins_id
     * @param projectReserveId
     * @return
     */
    String getByProjectReserveId(String projectReserveId);

    /**
     * 根据executeId查出历史节点信息
     * @param executeId
     * @return
     */
    List<History> getHistoryByExecuteId(String executeId);

    /**
     * 根据executeId查出当前节点的名称
     * @param executeId
     * @return
     */
    String getByExecuteId(String executeId);
}
